##################

proc seehelp {helpfile} {

    global croot helpinfo

    set extrapath "/lib/coral.help/"

    set fullpath  "$croot$extrapath$helpfile"

    set fid [open $fullpath r]

    gets $fid helpinfo

    while {! [eof $fid]} {
        append helpinfo "\n " [gets $fid]
    }

    close $fid

    mkHelp {OK {}}
    tkwait visibility .helpwin
    tkwait window .helpwin
}

####################
# mkHelp list list ...
#
# Create a help window with a message given in the variable helpinfo
#    (global)
#

proc mkHelp {args} {

    global helpinfo

    catch {destroy .helpwin}
    toplevel .helpwin -class Dialog
    wm title .helpwin "Coral Help"
    wm iconname .helpwin "Coral Help"

    # Create two frames in the main window. The top frame will hold the
    # message and the bottom one will hold the buttons.  Arrange them
    # one above the other, with any extra vertical space split between
    # them.

    frame .helpwin.top -relief raised -border 1
    frame .helpwin.bot -relief raised -border 1
    pack .helpwin.top .helpwin.bot -side top -fill both -expand yes
    
     scrollbar .helpwin.top.sb -relief flat -command {.helpwin.top.msg yview}
     pack .helpwin.top.sb -side right -fill y

    # Create the message widget and arrange for it to be centered in the
    # top frame.
    
    text .helpwin.top.msg -font *-Courier-Bold-R-Normal-*-120-* \
        -wrap word -yscrollcommand ".helpwin.top.sb set"
    pack .helpwin.top.msg -side top -expand yes -padx 3 -pady 3

     .helpwin.top.msg insert insert $helpinfo

    # Create as many buttons as needed and arrange them from left to right
    # in the bottom frame.  Embed the left button in an additional sunken
    # frame to indicate that it is the default button, and arrange for that
    # button to be invoked as the default action for clicks and returns in
    # the dialog.

    if {[llength $args] > 0} {
        set arg [lindex $args 0]
        frame .helpwin.bot.0 -relief sunken -border 1
        pack .helpwin.bot.0 -side left -expand yes -padx 10 -pady 10
        button .helpwin.bot.0.button -text [lindex $arg 0] \
            -command "[lindex $arg 1]; destroy .helpwin"
        pack .helpwin.bot.0.button -expand yes -padx 6 -pady 6
        bind .helpwin <Return> "[lindex $arg 1]; destroy .helpwin"
        focus .helpwin

        set i 1
        foreach arg [lrange $args 1 end] {
               button .helpwin.bot.$i -text [lindex $arg 0] \
                   -command "[lindex $arg 1]; destroy .helpwin"
            pack .helpwin.bot.$i -side left -expand yes -padx 10
               set i [expr $i+1]
        }
    }
    bind .helpwin <Any-Enter> [list focus .helpwin]
    focus .helpwin
}

####################
