#ifndef _RDBSYBASESYSTEM_H_
#define _RDBSYBASESYSTEM_H_

#include <sys/types.h>
#include "RdbSystem.h"
#include "String.h"
#include "sybase.h"

class RdbSybaseSystem
: public RdbSystem
{
  public:

    RdbSybaseSystem();
    
    ~RdbSybaseSystem();
    
    virtual String SystemName() const;	// "sybase"

    virtual RdbDatabase* OpenDatabase(const String dbName,
				      const String userid = String(),
				      const String password = String(),
				      const String serverName = String() );
				// open a sybase database

    String GetOid();

    virtual void const* Implementor() const;

  private:

    //------------------------------------------------------------------------
    //  Oid management:
    //         oid's are made as "rdb<pid><time><serial>"
    //         in order to create virtually unique object ids,
    //         even when multiple copies of this code are running.
    //         all variables are printed in hex.

    pid_t  pid;			// this process id

    time_t time_ms;		// time that the manager started

    unsigned long serialNum;	// a running count of the number of
				// id's handed out
    //-------------------------------------------------------------------------

    RdbSybaseSystem(const RdbSybaseSystem&); // not allowed

    RdbSybaseSystem& operator =(const RdbSybaseSystem&); // not allowed

};

#include "RdbSybaseSystem.i"

#endif // _RDBSYBASESYSTEM_H_
