
// Utilities for Embedded Coral

#include <iostream.h>
#include <ctype.h>

#include "Interface.h"
#include "util.h"

char letters[] = "abcdefghijklmnopqrstuvwxyz";

// ++++++++++++++++++++++++++++++++++++++++++++++++++
//   Simulate what we need, neither getline() or get() quite do it.
int cin_gets(char *buff, int n)
{
    char c;
    int  tot = 0;

    n--;

    do {
        cin.get(c);

        if (cin.eof()) {
            break;
        }

       *buff++ = c;
        tot++;

    } while ((tot < n) && (c != '\n'));

   *buff = '\0';

    return(tot);
}

// ++++++++++++++++++++++++++++++++++++++++++++++++++
void show_menu(char **menu)
{
    int j = 0;
    char mch = 'a';

    cout << endl;

    while (menu[j]) {
        cout << "  " << mch << ") " << menu[j];
        j++;
        mch++;
    }

    cout << endl << "option: " << flush; 
}

// ++++++++++++++++++++++++++++++++++++++++++++++++++
// Get a letter choice and convert it into an offset
// starting from 'a', or -1 if invalid
int get_choice()
{
    char buff[201], *ptr, ch;
    int choice = 0;

    buff[200] = '\0';
    ptr = buff;

    cin_gets(buff,200);

    while (isspace(*ptr))
        ptr++;

    ch = *ptr;
    if (! isalpha(ch))
        return(-1);

    if (isupper(ch))
        ch = tolower(ch);

    choice = ch - 'a';
    return(choice);
}

// ++++++++++++++++++++++++++++++++++++++++++++++++++
char *get_num(char *buff, int& n)
{
    while (*buff && isspace(*buff))
        buff++;

    n = atoi(buff);

    while (*buff && !isspace(*buff))
        buff++;

    return(buff);
}

// ++++++++++++++++++++++++++++++++++++++++++++++++++
// Trim whitespace off the end.
void  chop( char *buff )
{
    int j = strlen(buff) - 1;
    while (isspace(buff[j]))
        j--;

    buff[j+1] = '\0';
}

// ++++++++++++++++++++++++++++++++++++++++++++++++++
// Initialize the Coral C++ interface
void Init()
{
    init_coral("embed");

    \[
       clear(interactive_mode).
       assign(answer_style,1).
    \]
    //  set(quiet_mode).
}

// ++++++++++++++++++++++++++++++++++++++++++++++++++
// Ask the user for a file to consult, and do it.
void Consult()
{
    char buff[201];

    cout << "\nEnter a filename to consult: " << flush;

    cin_gets(buff,200);
   
    chop(buff); 

    cout << endl;

    \[
        consult("data.F").
        consult(($string) $buff).
    \]
}

// ++++++++++++++++++++++++++++++++++++++++++++++++++
// listrels.
void ListRels()
{
    \[
        list_rels.
    \]
}

// ++++++++++++++++++++++++++++++++++++++++++++++++++
