// *************************************************************************
//    Util.h
// *************************************************************************

#ifndef _Util_H_
#define _Util_H_

#include <iostream.h>

#include "BitVector.h"

class CoralStream;
class Cor_CArg;
class Cor_Tuple;
class Cor_Relation;
class Cor_BindEnv;
class Cor_ArgList;
class Cor_Term;

// *************************************************************************

enum Cor_ArgType_Error {
    Coral_Args_Okay = 0,
    Coral_Not_Enough_Args,
    Coral_Too_Many_Args,
    Coral_Wrong_Type_Args
};

// A helpful type-checking function for solvers, and other times too.
// See the explanation of usage in Util.C;
// it returns the errors enumerated above.
Cor_ArgType_Error Cor_CheckArgTypes(Cor_ArgList& args,
        int min_args, int max_args,
        char *tlist=NULL, Cor_Term *terms=NULL,
        int copy_terms=1, Cor_BindEnv *env=NULL );

// *************************************************************************

int file_exists(char *name);

CoralStream *Cor_open_file(char *name);
CoralStream *Cor_open_infile(char *name, int mode = ios::in);
CoralStream *Cor_open_outfile(char *name, int mode = ios::out);

int   Cor_DisplayFile(char *file_name, int use_pager=1);
char *Cor_FindHelpFile(Cor_CArg *keywrd, int *ln_num=NULL);

char *Cor_mk_tmp_file_name(char *name);
char *Cor_make_done_prefix();

int Cor_ConvertAdornment(Cor_BitVector& bits, char *adorn_string,
        int adorn_length);

int Cor_consultFile(char *filename, char *stack_filename);
int Cor_consultFile(CoralStream *coral_in, char *stack_filename);
int Cor_consultBuff(char *buffer, char *buffname);

    // Consults the string if provided, otherwise uses the top item on
    // the parseStack.  The facts should not contain variables as they
    // are not yet handled properly (this should be added) - SPF
Cor_Tuple *Cor_parseFact(char *fact_str,
                Cor_CArg& rel_name, int *arity = NULL);

    // Reads fact/table files only
Cor_Relation *Cor_ReadRelation(char *infile_nme, int arity);

// *************************************************************************

#endif _Util_H_
