// *************************************************************************
//    ParseUtils.h
// *************************************************************************

#ifndef _ParseUtils_H_
#define _ParseUtils_H_

#include "CArg.h"
#include "BuiltinSymbols.h"
#include "Annotations.h"
#include "Stack.h"
#include "ExportInfo.h"

// *************************************************************************

class Cor_ParserStruct;
class Cor_ModuleInfo;
class Cor_PredAnnotations;
class Cor_Clause;

// *************************************************************************

extern void Cor_insert_into_set(Cor_CArg *set, Cor_CArg *element);

extern Cor_CArg *Cor_create_list(Cor_CArgStack*, Cor_CArg *cdr);

extern Cor_CArg *Cor_create_functor(Cor_CArgStack*, Cor_CArg*,
            Cor_ParserStruct *parserStruct = NULL);

extern Cor_CArg *Cor_create_multi_grouping(Cor_ParserStruct*, Cor_CArgStack*);
extern Cor_CArg *Cor_create_nested_multiset();

extern Cor_CArg *Cor_pull_out_arith_expr(Cor_ParserStruct*, Cor_CArgStack*);

extern int Cor_varname_enter(Cor_CArgStack *var_names, Cor_CArg *s);
extern int Cor_varname_lookup(Cor_CArgStack *var_names, Cor_CArg*);

extern void Cor_AddExportInfo(Cor_ParserStruct*, Cor_CArg*);
extern void Cor_complete_rule(Cor_Clause *, Cor_ParserStruct*);

extern void COR_set_supplementary_magic(Cor_ModuleInfo&, int val);
extern void COR_set_ordinary_magic(Cor_ModuleInfo&, int val);
extern void COR_set_no_magic(Cor_ModuleInfo&);
extern void COR_set_check_subsum(Cor_ModuleInfo&, int val);
extern void COR_set_multisets(Cor_ModuleInfo&, int val);
extern void COR_set_single_scc(Cor_ModuleInfo&, int val);
extern void COR_set_convert_functions(Cor_ModuleInfo&, int val);
extern void COR_set_use_factoring(Cor_ModuleInfo&, int val);
extern void COR_set_use_factormagic(Cor_ModuleInfo&, int val);
extern void COR_set_use_ordsearch(Cor_ModuleInfo&, int val);
extern void COR_set_return_unify(Cor_ModuleInfo&, int val);
extern void COR_set_pipelining(Cor_ModuleInfo&, int val);
extern void COR_set_index_deltas(Cor_ModuleInfo&, int val);
extern void COR_set_lazy_eval(Cor_ModuleInfo&, int val);
extern void COR_set_monotonic(Cor_ModuleInfo&, int val);
extern void COR_set_rewriting(Cor_ModuleInfo&, int val);
extern void COR_set_preprocessing(Cor_ModuleInfo&, int val);
extern void COR_set_disk_resident(Cor_ModuleInfo&, int);
extern void COR_set_naive_backtracking(Cor_ModuleInfo&, int);
extern void COR_set_nested_scc_eval(Cor_ModuleInfo&, int);


#endif _ParseUtils_H_
