// *************************************************************************
//    RuleInfo.h
// *************************************************************************

#ifndef _RuleInfo_H_
#define _RuleInfo_H_

#include "Profile.h"
#include "BindEnv.h"

// *************************************************************************

class Cor_Relation;
class Cor_Clause;

// *************************************************************************

class Cor_RuleInfo { 

  public:
    Cor_ArgList      *arg_list;
    int              *relations;
    int              *offsets;
    int               num_literals;
    int               num_vars;
#ifdef    DO_PROFILE
    Cor_ProfileInfo   pInfo;
#endif
    Cor_Clause       *rule;
    Cor_Relation    **headrel_ptr;

    Cor_RuleInfo(Cor_Clause *);
   ~Cor_RuleInfo();
}; 

// *************************************************************************

#define FORWARD 1
#define BACKWARD 0

// Define a couple of macros to avoid messy code within the function.

#define _PROFILE(X,Y,Z) \
   { \
     if ((Cor_exEnv->profile_sn)) {\
       pinfo->print(Cor_exEnv->profile_strm,"SNR",Y,Z);\
       Cor_AddProfileInfo(pinfo, &X);\
       pinfo->reset();\
     }\
     else if ((Cor_exEnv->profile_scc) || (Cor_exEnv->profile_module)) { \
         Cor_AddProfileInfo(pinfo, &X);\
             pinfo->reset(); \
          } \
   }

#define NEGATED(index) (rInfo->relations[index] < 0)

extern int do_rule(void *, Cor_RuleInfo *, int, int, ...);

// *************************************************************************

extern Cor_BindEnv *Cor_UnusedEnv;

// *************************************************************************

#endif _RuleInfo_H_
