//**************************************************************************
//    CoralStream.C
//
//    The CoralStream Class - A class to handle all I/O within Coral
//
//**************************************************************************

#ifndef _CORALSTREAM_H_
#define _CORALSTREAM_H_

#include <stdlib.h>
#include <unistd.h>
#include <string.h>

#include <sys/types.h>
#include <stdarg.h>

#include <iostream.h>
#include <fstream.h>

    // OST - Original Stream Type
enum Cor_Strm_T {
    OST_NONE = 0,
    OST_IFS,
    OST_OFS
};

//**************************************************************************

class CoralStream : public iostream {

  public:

    CoralStream(streambuf *sb, int delete_buffer=1);
   ~CoralStream();

    int   printf(char *fmt, ...);
    int   puts(char *buff, int add_nl = 0);
    int   putch(int ch);
    int   gets(char *buff, int n);

      // A place to store a pointer to the original stream, if any
    Cor_Strm_T     orig; 
    union {
        ifstream *ifs;
        ofstream *ofs;
    };

  private:

    int   _del_buffer;

    CoralStream(const CoralStream& other);
    CoralStream& operator=(const CoralStream& other);

};

//**************************************************************************

#endif   _CORALSTREAM_H_
